<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "prospect_provider".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProspectProvider".
 *
 * Columns in table "prospect_provider" available as properties of the model,
 * followed by relations of table "prospect_provider" available as properties of the model.
 *
 * @property integer $id
 * @property integer $prospect_id
 * @property string $npi
 * @property integer $provider_id
 * @property string $first_name
 * @property string $middle_name
 * @property string $last_name
 * @property string $full_name
 * @property string $credential
 * @property string $specialty
 * @property string $gender
 *
 * @property Prospect $prospect
 * @property Provider $provider
 * @property ProspectProviderPractice[] $prospectProviderPractices
 */
abstract class BaseProspectProvider extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'prospect_provider';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProspectProvider|ProspectProviders', $n);
    }

    public static function representingColumn()
    {
        return 'npi';
    }

    public function rules()
    {
        return array(
            array('prospect_id, provider_id', 'numerical', 'integerOnly'=>true),
            array('npi', 'length', 'max'=>10),
            array('first_name, credential', 'length', 'max'=>50),
            array('middle_name', 'length', 'max'=>20),
            array('last_name', 'length', 'max'=>80),
            array('full_name', 'length', 'max'=>150),
            array('specialty', 'length', 'max'=>100),
            array('gender', 'length', 'max'=>1),
            array('prospect_id, npi, provider_id, first_name, middle_name, last_name, full_name, credential, specialty, gender', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, prospect_id, npi, provider_id, first_name, middle_name, last_name, full_name, credential, specialty, gender', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'prospect' => array(self::BELONGS_TO, 'Prospect', 'prospect_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'prospectProviderPractices' => array(self::HAS_MANY, 'ProspectProviderPractice', 'prospect_provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'prospect_id' => null,
            'npi' => Yii::t('app', 'Npi'),
            'provider_id' => null,
            'first_name' => Yii::t('app', 'First Name'),
            'middle_name' => Yii::t('app', 'Middle Name'),
            'last_name' => Yii::t('app', 'Last Name'),
            'full_name' => Yii::t('app', 'Full Name'),
            'credential' => Yii::t('app', 'Credential'),
            'specialty' => Yii::t('app', 'Specialty'),
            'gender' => Yii::t('app', 'Gender'),
            'prospect' => null,
            'provider' => null,
            'prospectProviderPractices' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('prospect_id', $this->prospect_id);
        $criteria->compare('npi', $this->npi, true);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('first_name', $this->first_name, true);
        $criteria->compare('middle_name', $this->middle_name, true);
        $criteria->compare('last_name', $this->last_name, true);
        $criteria->compare('full_name', $this->full_name, true);
        $criteria->compare('credential', $this->credential, true);
        $criteria->compare('specialty', $this->specialty, true);
        $criteria->compare('gender', $this->gender, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
